import pytest

from .utilities import clean_temporary_pub, create_temporary_pub


@pytest.fixture
def pub(request):
    return create_temporary_pub(sql_mode=True)


def teardown_module(module):
    clean_temporary_pub()


def test_deprecated_error(pub):
    pub.loggederror_class.wipe()

    pub.record_deprecated_usage('foo bar')
    assert pub.loggederror_class.count() == 1
    error = pub.loggederror_class.select()[0]
    assert error.summary == '[DEPRECATED] foo bar'
    assert error.kind == 'deprecated_usage'
    assert error.occurences_count == 1

    pub.record_deprecated_usage('foo bar')
    pub.record_deprecated_usage('foo bar')
    assert pub.loggederror_class.count() == 1
    error = pub.loggederror_class.select()[0]
    assert error.summary == '[DEPRECATED] foo bar'
    assert error.kind == 'deprecated_usage'
    assert error.occurences_count == 3
